import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * 
 * @author Sjaak Smetsers & Renske Smetsers-Weeda
 * @version 2.0 -- 08-08-2015
 */
public class MyDodo extends Dodo
{
    private int myNrOfEggsHatched;

    public MyDodo() {
        this ( EAST );
    }

    public MyDodo( int init_direction ) {
        super ( init_direction );
        myNrOfEggsHatched = 0;
    }

    /**
     * Go to the edge of the world and
     * walk along the border
     */
    public void act() {
        if ( canMove() ) {
            move( );
        } else {
            turnRight();
        }
    }

    /**
     * 
     */    
    public void hatchEgg () {
        if ( foundEgg() ) {
            removeActor( getEgg() );
            myNrOfEggsHatched++;
        } else {
            showError( "There was no egg in this cell" );
        }
    }

    public int getNrOfEggsHatched() {
        return myNrOfEggsHatched;
    }

    /**
     * Move one cell forward in the current direction.
     */
    public void move() {
        if ( canMove() ) {
            step();
        } else {
            showError( "I'm stuck!" );
        }
    }

    /**
     * Move given number of cells forward in the current direction.
     * @param distance: the number of steps made
     */
    public void jump( int distance ) {
        int steps = 0;
        while ( steps < distance ) {
            move();
            steps++;
        }
    }

    /**
     * Test if we can move forward. Return true if we can, false otherwise.
     */
    public boolean canMove() {
        if ( ! borderAhead() ){
            return true;
        } else {
            return false;
        }
    } 

}
